// ramp entry code phaeno pinball
// runs on arduino pro mini

#define LICHTORGEL 3
#define SPEAKER 6
#define LDR A0


int p_laser;
int laser[100];
int lasercount;
int long light_off_time;
 
void setup(){
  pinMode(LICHTORGEL, OUTPUT);
  pinMode(SPEAKER, OUTPUT);
  
  delay(100);
  for (int i=0;i<100;i++){
    laser[i]=analogRead(LDR);
  }
}

void loop(){
  lasercount++; //ringbuffer counter
  lasercount=lasercount%100;
  laser[lasercount]=analogRead(LDR); //read LDR value and write it into ringbuffer
  
  if (millis()>light_off_time){digitalWrite (LICHTORGEL, LOW);}
  
  if (abs(laser[lasercount]-laser[(lasercount+1)%100])>10){ //ball entered gate --> action
      digitalWrite (LICHTORGEL, HIGH);
      light_off_time=millis()+5000; //defines when light has to be switched off again
      
      
 for (int j=40;j<2000;j+=200){
        for (int i=j;i<j+1000;i+=80){
          tone(SPEAKER,i);
          delay(3);
          noTone(SPEAKER); 
          digitalWrite(SPEAKER,HIGH);
          delay(1);
          digitalWrite(SPEAKER,LOW);
          delay(11-(i/300));
        }
    }      
      for (int i=0;i<100;i++){ //overwrite ringbuffer with current LDR values
        laser[i]=analogRead(LDR);
      }
  }
  



}
