// slingshot code phaeno pinball
// TODO: Score muss noch eingebaut werden

#define TOY 8
#define FOENS 2
#define LEDS 5
#define STATUSLED1 13
#define STATUSLED2 12
#define IR1 0
#define IR2 1
#define POTI1 3
#define POTI2 2
#define SCORE 3

int ledpwm=10;
int toyreset=-45;
int toycount=toyreset;
int foencount=0;
int scorereset=-45;
int scorecount=scorereset;

void setup(){
pinMode(TOY, OUTPUT);
pinMode(FOENS, OUTPUT);
pinMode(LEDS, OUTPUT);
pinMode(STATUSLED1, OUTPUT);
pinMode(STATUSLED2, OUTPUT);
pinMode(SCORE,OUTPUT);
Serial.begin(9600);
}

void loop(){
  
   boolean hit=false;
   
   // check IR sensor 1
   int ir1=0;
   int poti1=0;
   for (int i=0;i<10;i++){          // read adc's 10x to reduce noise
     ir1 += analogRead(IR1);        // larger values=closer
     poti1 += analogRead(POTI1);    // turn to left = larger values
   }
   if (ir1>poti1){
     digitalWrite(STATUSLED1,HIGH);
     hit=true;
   }else{
     digitalWrite(STATUSLED1,LOW);
   }
   
   // check IR sensor 2
   int ir2=0;
   int poti2=0;
   for (int i=0;i<10;i++){          // read adc's 10x to reduce noise
     ir2 += analogRead(IR2);        // larger values=closer
     poti2 += analogRead(POTI2);    // turn to left = larger values
   }
   if (ir2>poti2){
     digitalWrite(STATUSLED2,HIGH);
     hit=true;
   }else{
     digitalWrite(STATUSLED2,LOW);
   }
   
   // timing when ball hits the IR beams
   if (hit){
     ledpwm=255;
     if (toycount==toyreset){toycount=90;}else{if (toycount>0)toycount--;}
     if (scorecount==scorereset){scorecount=5;}else{if (scorecount>0)scorecount--;}
     foencount=75;
   }else{
     ledpwm=(ledpwm*20+1)/21;
     if (toycount>toyreset)toycount--;
     if (foencount)foencount--;
     if (scorecount>scorereset)scorecount--;
   }
 
   // switching of LED strip and TOY
   //-> blinky effect  if(ledpwm>1){if ((millis()/20)%3){analogWrite(LEDS,ledpwm);}else{analogWrite(LEDS,0);}}else{analogWrite(LEDS,ledpwm);}
     analogWrite(LEDS,ledpwm);
     if (toycount>0){digitalWrite(TOY,HIGH);}else{digitalWrite(TOY,LOW);}
     if (foencount){digitalWrite(FOENS,HIGH);}else{digitalWrite(FOENS,LOW);}
     if (scorecount>0){digitalWrite(SCORE,HIGH);}else{digitalWrite(SCORE,LOW);}
     //debug:
    /* Serial.print(ir1);
     Serial.print(" ... ");
     Serial.print(ir2);
     Serial.print(" ... ");
     Serial.print(poti1);
     Serial.print(" ... ");
     Serial.println(poti2);
     delay(100);
     */
     //end of debug
}
